local l,C = BixLib,Growler_Constants
local _,L = ...

local function printoption(opt)
	local val = "on/off"
	if opt.type == "number" then
		val = tostring(opt.min).."-"..tostring(opt.max)
	end
	local description = opt.description and " - ("..opt.description..")" or ""
	print(C.color.green.."/growl "..opt.slash.." "..val..description)
end


SLASH_GROWLER1 = "/growler"
SLASH_GROWLER2 = "/growl"
SlashCmdList["GROWLER"] = function(msg)
	local class = tostring(UnitClass("player"))
	local isHunter = (class == L["Hunter"])
	if (not msg or msg == "" or msg == "help") then
		print(" ")
		print(C.color.blue.."Growler slash commands:")
		print(C.color.blue.."These commands CAN be used in combat:")
		if isHunter then
			for c,cat in pairs(C.Options) do
				for o,opt in pairs(C.Options[c]) do
					if opt.hunteronly and opt.combat then
						printoption(opt)
					end
				end
			end
			print(C.color.blue.."These commands can NOT be used combat:")
			for c,cat in pairs(C.Options) do
				for o,opt in pairs(C.Options[c]) do
					if opt.hunteronly and not opt.combat then
						printoption(opt)
					end
				end
			end
		else
			for c,cat in pairs(C.Options) do
				for o,opt in pairs(C.Options[c]) do
					if not opt.hunteronly and opt.combat then
						printoption(opt)
					end
				end
			end
			print(C.color.blue.."These commands can NOT be used combat:")
			for c,cat in pairs(C.Options) do
				for o,opt in pairs(C.Options[c]) do
					if not opt.hunteronly and not opt.combat then
						printoption(opt)
					end
				end
			end
		end
	else
		local optionexists = false
		if msg == "settings" then
			InterfaceOptionsFrame_OpenToCategory(getglobal("GrowlerOptions"))
			InterfaceOptionsFrame_OpenToCategory(getglobal("GrowlerOptions"))
			optionexists = true
		else
			local msg = string.lower(msg)
			local option, value = string.match(msg,"(%S+)%s+(%S+)")
			-- local number = tonumber(string.match(value,"^(%d+)$"))
			-- local float = tonumber(string.match(value,"^([%d]+\.[%d]+)$"))
			local bool = nil
			if value == "on" then
				bool = true
			elseif value == "off" then
				bool = false
			end
			
			local number = tonumber(value)
			
			for c,cat in pairs(C.Options) do
				for o,opt in pairs(C.Options[c]) do
					if option==opt.slash then
						if (isHunter or not opt.hunteronly) and not (InCombatLockdown() and not opt.combat) then
							if opt.type == "bool" then
								if bool~=nil then
									GrowlerDB.options[o] = bool
									optionexists = true
									if GrowlerDB.options.slashmsg then print(C.color.green..opt.slash.." is now "..value) end
								else
									print(C.color.red.."Invalid value. Can only use 'on' or 'off' with this command.")
									optionexists = true
								end
							elseif opt.type == "number" then
								if number and number <= opt.max and number >= opt.min then
									GrowlerDB.options[o] = number
									optionexists = true
									if GrowlerDB.options.slashmsg then print(C.color.green..opt.slash.." is now set to "..value) end
								else
									print(C.color.red.."Invalid value. Can only use numbers in the range "..tostring(opt.min).."-"..tostring(opt.max).." with this command.")
									optionexists = true
								end
							end
							if not InCombatLockdown() then
								Growler.btn.growl.updatemacro()
								Growler.btn.call.updatemacro()
								Growler.bar.SavePos()
								Growler.bar.ResetPos()
							end
						elseif InCombatLockdown() and opt.combat == false then
							print(C.color.red.."That option cannot be used in combat.")
							optionexists = true
						end
						break
					elseif msg==opt.slash then
						print(C.color.red.."You must enter a value with this command. Type /growler to see a list.")
						optionexists = true
						break
					end
				end
			end
		end
		
		if not optionexists then
			print(C.color.red.."No such command. Type /growler to see a list of commands.")
		end
	end
end


-- SLASH_TEST1 = "/test"
-- SlashCmdList["TEST"] = function(msg)
	-- if msg then
		-- local isnumber = tonumber(msg)
		-- print(tostring(isnumber))
	-- end
-- end

-- SlashCmdList["GROWLER"] = function(msg)
	-- local class = tostring(UnitClass("player"))
	-- local isHunter = (class == L["Hunter"])
	-- if (not msg or msg == "" or msg == "help") then
		-- print(" ")
		-- print("Growler slash commands:")
		-- if isHunter then
			-- print("These commands CAN be used in combat:")
		-- end
		-- print("/growl help    -  Shows this list.")
		-- print("/growl settings    -  Brings up the settings panel.")
		-- if isHunter then
			-- print("/growl listtoggles    -  print a list of options to be used with certain commands")
			-- print("/growl option on/off    -  Enable/disable the option as listed in /growl listtoggles (excluding description in parentheses)")
			-- print("/growl snooze 5-300    -  For how long should alerts be delayed after right-clicking it.")
			-- print("/growl mendat 10-100    -  At how much health% should Growler alert for Mend Pet.")
			-- print("These commands can NOT be used combat:")
			-- print("/growl barsize 0.8-2.0    -  Change the size of the bar.")
		-- end
	-- else
		-- local msg = string.lower(msg)
		-- local option, value = string.match(string.lower(msg),"(%S*)%s*([%S%d%a]+)")
		-- local number = tonumber(string.match(value,"^(%d+)$"))
		-- local float = tonumber(string.match(value,"^([%d]+\.[%d]+)$"))
		-- -- COMBAT
		-- if (msg == "settings") then
			-- InterfaceOptionsFrame_OpenToCategory(getglobal("GrowlerOptions"))
			-- InterfaceOptionsFrame_OpenToCategory(getglobal("GrowlerOptions"))
			-- return
		-- end
		-- if isHunter then
			-- if (msg == "listtoggles") then
				-- print("These options can be toggled in combat:")
				-- for cmd,o in pairs(noncombattoggles) do
					-- local d = o and 
					-- print(cmd,"("..d..")")
				-- end
				-- print("These options can NOT be toggled in combat:")
				-- for cmd,o in ipairs(combattoggles) do
					-- print(cmd,"("..d..")")
				-- end
				-- return
			-- else
				-- for cmd,o in pairs(noncombattoggles) do
					-- if option == cmd then
						
					-- end
				-- end
			-- end
			
			-- -- elseif (msg == "slashmsg on") then
				-- -- GrowlerDB.options.slashmsg = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Confirmation messages enabled.") end
				-- -- return
			-- -- elseif (msg == "slashmsg off") then
				-- -- GrowlerDB.options.slashmsg = false
				-- -- return
			-- -- elseif (msg == "sound on") then
				-- -- GrowlerDB.options.sound = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Sounds enabled.") end
				-- -- return
			-- -- elseif (msg == "sound off") then
				-- -- GrowlerDB.options.sound = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Sounds disabled.") end
				-- -- return
			-- -- elseif (msg == "remind on") then
				-- -- GrowlerDB.options.reminder = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Now keeps making sounds when no action is taken.") end
				-- -- return
			-- -- elseif (msg == "remind off") then
				-- -- GrowlerDB.options.reminder = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Now stops making sounds when no action is taken.") end
				-- -- return
			-- -- elseif (msg == "notify on") then
				-- -- GrowlerDB.options.notifygroup = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Now notifies group when another player's pet is using growl.") end
				-- -- return
			-- -- elseif (msg == "notify off") then
				-- -- GrowlerDB.options.notifygroup = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Now stops notifying group when another player's pet is using growl.") end
				-- -- return
			-- -- elseif (msg == "screenicons on") then
				-- -- GrowlerDB.options.screenicons = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Enabled screen icons.") end
				-- -- return
			-- -- elseif (msg == "screenicons off") then
				-- -- GrowlerDB.options.screenicons = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Disabled screen icons.") end
				-- -- return
			-- -- elseif (option == "snooze" and number<301 and number>4) then
				-- -- GrowlerDB.options.snooze = number
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Snooze timer set to " .. tostring(number) .. " seconds.") end
				-- -- return
			-- -- elseif (msg == "growl on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Growl enabled.") end
				-- -- return
			-- -- elseif (msg == "growl off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Growl disabled.") end
				-- -- return
			-- -- elseif (msg == "call on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Call Pet enabled.") end
				-- -- return
			-- -- elseif (msg == "call off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Call Pet disabled.") end
				-- -- return
			-- -- elseif (msg == "revive on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Revive Pet enabled.") end
				-- -- return
			-- -- elseif (msg == "revive off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Revive Pet disabled.") end
				-- -- return
			-- -- elseif (msg == "mend on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Mend Pet enabled.") end
				-- -- return
			-- -- elseif (msg == "mend off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Mend Pet disabled.") end
				-- -- return
			-- -- elseif (option == "mendat" and number<101 and number >9) then
				-- -- GrowlerDB.options.mend_threshhold = number/100
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Mend will now alert when your pet is below " .. number .. "% health.") end
				-- -- return
			-- -- elseif (msg == "playdead on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Play Dead enabled.") end
				-- -- return
			-- -- elseif (msg == "playdead off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Play Dead disabled.") end
				-- -- return
			-- -- elseif (msg == "wakeup on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Wake Up enabled.") end
				-- -- return
			-- -- elseif (msg == "wakeup off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for Wake Up disabled.") end
				-- -- return
			-- -- elseif (msg == "passive on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on passive enabled.") end
				-- -- return
			-- -- elseif (msg == "passive off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on passive disabled.") end
				-- -- return
			-- -- elseif (msg == "assist on") then
				-- -- GrowlerDB.options.enable_growl = true
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on assist enabled.") end
				-- -- return
			-- -- elseif (msg == "assist off") then
				-- -- GrowlerDB.options.enable_growl = false
				-- -- if GrowlerDB.options.slashmsg then Growler.msg("Alert for putting your pet on assist disabled.") end
				-- -- return
			-- -- end
			-- -- NO COMBAT
			-- if not InCombatLockdown() then
				-- if (msg == "buttons on") then
					-- GrowlerDB.options.enable = true
					-- if GrowlerDB.options.slashmsg then Growler.msg("Buttons enabled.") end
				-- elseif (msg == "buttons off") then
					-- GrowlerDB.options.enable = false
					-- if GrowlerDB.options.slashmsg then Growler.msg("Buttons disabled.") end
				-- elseif (msg == "nonparty on") then
					-- GrowlerDB.options.nonparty = true
					-- if GrowlerDB.options.slashmsg then Growler.msg("Enabled growl alert when not in a party.") end
				-- elseif (msg == "nonparty off") then
					-- GrowlerDB.options.nonparty = false
					-- if GrowlerDB.options.slashmsg then Growler.msg("Disabled growl alert when not in a party.") end
				-- elseif (msg == "petbuttons on") then
					-- GrowlerDB.options.showpets = true
					-- if GrowlerDB.options.slashmsg then Growler.msg("Now showing call/dismiss pet buttons.") end
				-- elseif (msg == "petbuttons off") then
					-- GrowlerDB.options.showpets = false
					-- if GrowlerDB.options.slashmsg then Growler.msg("Now hiding call/dismiss pet buttons.") end
				-- elseif (msg == "petsbottom on") then
					-- GrowlerDB.options.petsbottom = true
					-- if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the call/dismiss pet buttons at the bottom of the bar.") end
				-- elseif (msg == "petsbottom off") then
					-- GrowlerDB.options.petsbottom = false
					-- if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the call/dismiss pet buttons at the top of the bar.") end
				-- elseif (msg == "specsbottom on") then
					-- GrowlerDB.options.specsbottom = true
					-- if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the pet respec buttons at the bottom of the bar.") end
				-- elseif (msg == "specsbottom off") then
					-- GrowlerDB.options.specsbottom = false
					-- if GrowlerDB.options.slashmsg then Growler.msg("Now displaying the pet respec buttons at the top of the bar.") end
				-- elseif (option == "barsize" and float and float<=2.0 and float >=0.8) then
					-- GrowlerDB.options.barsize = float
					-- if GrowlerDB.options.slashmsg then Growler.msg("Bar size changed.") end
				-- elseif (msg == "savepos on") then
					-- GrowlerDB.options.savepos = true
					-- if GrowlerDB.options.slashmsg then Growler.msg("Bar position will now be saved.") end
				-- elseif (msg == "savepos off") then
					-- GrowlerDB.options.savepos = false
					-- if GrowlerDB.options.slashmsg then Growler.msg("Bar position will now not be saved.") end
				-- end
				-- Growler.bar.ResetPos()
			-- else
				-- Growler.msg("You cannot change that setting in combat.",true)
			-- end
		-- end
	-- end
-- end